Package org.springframework.jdbc.support.lob

# Class DefaultLobHandler

java.lang.Object
org.springframework.jdbc.support.lob.AbstractLobHandler
org.springframework.jdbc.support.lob.DefaultLobHandler

All Implemented Interfaces:
  `LobHandler`

@Deprecated(since="6.2") public class DefaultLobHandler extends AbstractLobHandler
Deprecated.
as of 6.2, in favor of `SqlBinaryValue` and `SqlCharacterValue`
Default implementation of the `LobHandler` interface. Invokes the direct accessor methods that `java.sql.ResultSet` and `java.sql.PreparedStatement` offer.

By default, incoming streams are going to be passed to the appropriate `setBinary/Ascii/CharacterStream` method on the JDBC driver's `PreparedStatement`. If the specified content length is negative, this handler will use the JDBC 4.0 variants of the set-stream methods without a length parameter; otherwise, it will pass the specified length on to the driver.

This LobHandler should work for any JDBC driver that is JDBC compliant in terms of the spec's suggestions regarding simple BLOB and CLOB handling. This does not apply to Oracle 9i's drivers at all; as of Oracle 10g, it does work but may still come with LOB size limitations. Consider using recent Oracle drivers even when working against an older database server. See the `LobHandler` javadoc for the full set of recommendations.

Some JDBC drivers require values with a BLOB/CLOB target column to be explicitly set through the JDBC `setBlob` / `setClob` API: for example, PostgreSQL's driver. Switch the `"wrapAsLob"` property to "true" when operating against such a driver.

On JDBC 4.0, this LobHandler also supports streaming the BLOB/CLOB content via the `setBlob` / `setClob` variants that take a stream argument directly. Consider switching the `"streamAsLob"` property to "true" when operating against a fully compliant JDBC 4.0 driver.

Finally, this LobHandler also supports the creation of temporary BLOB/CLOB objects. Consider switching the `"createTemporaryLob"` property to "true" when "streamAsLob" happens to run into LOB size limitations.

See the `LobHandler` interface javadoc for a summary of recommendations.

Since:
  04.12.2003
Author:
  Juergen Hoeller
See Also:
  - `ResultSet.getBytes(int)`
  - `ResultSet.getBinaryStream(int)`
  - `ResultSet.getString(int)`
  - `ResultSet.getAsciiStream(int)`
  - `ResultSet.getCharacterStream(int)`
  - `PreparedStatement.setBytes(int, byte[])`
  - `PreparedStatement.setBinaryStream(int, java.io.InputStream, int)`
  - `PreparedStatement.setString(int, java.lang.String)`
  - `PreparedStatement.setAsciiStream(int, java.io.InputStream, int)`
  - `PreparedStatement.setCharacterStream(int, java.io.Reader, int)`

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`DefaultLobHandler.DefaultLobCreator`
Deprecated.
Default LobCreator implementation as an inner class.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final org.apache.commons.logging.Log`
`logger`
Deprecated.

## Constructor Summary

Constructors
Constructor
Description
`DefaultLobHandler()`
Deprecated.

## Method Summary

Modifier and Type
Method
Description
`InputStream`
`getBlobAsBinaryStream(ResultSet rs, int columnIndex)`
Deprecated.
Retrieve the given column as binary stream from the given ResultSet.
`byte[]`
`getBlobAsBytes(ResultSet rs, int columnIndex)`
Deprecated.
Retrieve the given column as bytes from the given ResultSet.
`InputStream`
`getClobAsAsciiStream(ResultSet rs, int columnIndex)`
Deprecated.
Retrieve the given column as ASCII stream from the given ResultSet.
`Reader`
`getClobAsCharacterStream(ResultSet rs, int columnIndex)`
Deprecated.
Retrieve the given column as character stream from the given ResultSet.
`String`
`getClobAsString(ResultSet rs, int columnIndex)`
Deprecated.
Retrieve the given column as String from the given ResultSet.
`LobCreator`
`getLobCreator()`
Deprecated.
Create a new `LobCreator` instance, i.e.
`void`
`setCreateTemporaryLob(boolean createTemporaryLob)`
Deprecated.
Specify whether to copy a byte array / String into a temporary JDBC Blob / Clob object created through the JDBC 4.0 `createBlob` / `createClob` methods.
`void`
`setStreamAsLob(boolean streamAsLob)`
Deprecated.
Specify whether to submit a binary stream / character stream to the JDBC driver as explicit LOB content, using the JDBC 4.0 `setBlob` / `setClob` method with a stream argument.
`void`
`setWrapAsLob(boolean wrapAsLob)`
Deprecated.
Specify whether to submit a byte array / String to the JDBC driver wrapped in a JDBC Blob / Clob object, using the JDBC `setBlob` / `setClob` method with a Blob / Clob argument.

### Methods inherited from class org.springframework.jdbc.support.lob.AbstractLobHandler

`getBlobAsBinaryStream, getBlobAsBytes, getClobAsAsciiStream, getClobAsCharacterStream, getClobAsString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### logger

protected final org.apache.commons.logging.Log logger
Deprecated.

## Constructor Details

### DefaultLobHandler

public DefaultLobHandler()
Deprecated.

## Method Details

### setWrapAsLob

public void setWrapAsLob(boolean wrapAsLob)
Deprecated.
Specify whether to submit a byte array / String to the JDBC driver wrapped in a JDBC Blob / Clob object, using the JDBC `setBlob` / `setClob` method with a Blob / Clob argument.

Default is "false", using the common JDBC 2.0 `setBinaryStream` / `setCharacterStream` method for setting the content. Switch this to "true" for explicit Blob / Clob wrapping against JDBC drivers that are known to require such wrapping (for example, PostgreSQL's for access to OID columns, whereas BYTEA columns need to be accessed the standard way).

This setting affects byte array / String arguments as well as stream arguments, unless `"streamAsLob"` overrides this handling to use JDBC 4.0's new explicit streaming support (if available).

See Also:
  - `PreparedStatement.setBlob(int, java.sql.Blob)`
  - `PreparedStatement.setClob(int, java.sql.Clob)`

### setStreamAsLob

public void setStreamAsLob(boolean streamAsLob)
Deprecated.
Specify whether to submit a binary stream / character stream to the JDBC driver as explicit LOB content, using the JDBC 4.0 `setBlob` / `setClob` method with a stream argument.

Default is "false", using the common JDBC 2.0 `setBinaryStream` / `setCharacterStream` method for setting the content. Switch this to "true" for explicit JDBC 4.0 streaming, provided that your JDBC driver actually supports those JDBC 4.0 operations (for example, Derby's).

This setting affects stream arguments as well as byte array / String arguments, requiring JDBC 4.0 support. For supporting LOB content against JDBC 3.0, check out the `"wrapAsLob"` setting.

See Also:
  - `PreparedStatement.setBlob(int, java.io.InputStream, long)`
  - `PreparedStatement.setClob(int, java.io.Reader, long)`

### setCreateTemporaryLob

public void setCreateTemporaryLob(boolean createTemporaryLob)
Deprecated.
Specify whether to copy a byte array / String into a temporary JDBC Blob / Clob object created through the JDBC 4.0 `createBlob` / `createClob` methods.

Default is "false", using the common JDBC 2.0 `setBinaryStream` / `setCharacterStream` method for setting the content. Switch this to "true" for explicit Blob / Clob creation using JDBC 4.0.

This setting affects stream arguments as well as byte array / String arguments, requiring JDBC 4.0 support. For supporting LOB content against JDBC 3.0, check out the `"wrapAsLob"` setting.

See Also:
  - `Connection.createBlob()`
  - `Connection.createClob()`

### getBlobAsBytes

@Nullable public byte[] getBlobAsBytes(ResultSet rs, int columnIndex) throws SQLException
Deprecated.
Description copied from interface: `LobHandler`
Retrieve the given column as bytes from the given ResultSet. Might simply invoke `ResultSet.getBytes` or work with `ResultSet.getBlob`, depending on the database and driver.

Parameters:
  `rs` - the ResultSet to retrieve the content from
  `columnIndex` - the column index to use
Returns:
  the content as byte array, or `null` in case of SQL NULL
Throws:
  `SQLException` - if thrown by JDBC methods
See Also:
  - `ResultSet.getBytes(int)`

### getBlobAsBinaryStream

@Nullable public InputStream getBlobAsBinaryStream(ResultSet rs, int columnIndex) throws SQLException
Deprecated.
Description copied from interface: `LobHandler`
Retrieve the given column as binary stream from the given ResultSet. Might simply invoke `ResultSet.getBinaryStream` or work with `ResultSet.getBlob`, depending on the database and driver.

Parameters:
  `rs` - the ResultSet to retrieve the content from
  `columnIndex` - the column index to use
Returns:
  the content as binary stream, or `null` in case of SQL NULL
Throws:
  `SQLException` - if thrown by JDBC methods
See Also:
  - `ResultSet.getBinaryStream(int)`

### getClobAsString

@Nullable public String getClobAsString(ResultSet rs, int columnIndex) throws SQLException
Deprecated.
Description copied from interface: `LobHandler`
Retrieve the given column as String from the given ResultSet. Might simply invoke `ResultSet.getString` or work with `ResultSet.getClob`, depending on the database and driver.

Parameters:
  `rs` - the ResultSet to retrieve the content from
  `columnIndex` - the column index to use
Returns:
  the content as String, or `null` in case of SQL NULL
Throws:
  `SQLException` - if thrown by JDBC methods
See Also:
  - `ResultSet.getString(int)`

### getClobAsAsciiStream

public InputStream getClobAsAsciiStream(ResultSet rs, int columnIndex) throws SQLException
Deprecated.
Description copied from interface: `LobHandler`
Retrieve the given column as ASCII stream from the given ResultSet. Might simply invoke `ResultSet.getAsciiStream` or work with `ResultSet.getClob`, depending on the database and driver.

Parameters:
  `rs` - the ResultSet to retrieve the content from
  `columnIndex` - the column index to use
Returns:
  the content as ASCII stream, or `null` in case of SQL NULL
Throws:
  `SQLException` - if thrown by JDBC methods
See Also:
  - `ResultSet.getAsciiStream(int)`

### getClobAsCharacterStream

public Reader getClobAsCharacterStream(ResultSet rs, int columnIndex) throws SQLException
Deprecated.
Description copied from interface: `LobHandler`
Retrieve the given column as character stream from the given ResultSet. Might simply invoke `ResultSet.getCharacterStream` or work with `ResultSet.getClob`, depending on the database and driver.

Parameters:
  `rs` - the ResultSet to retrieve the content from
  `columnIndex` - the column index to use
Returns:
  the content as character stream
Throws:
  `SQLException` - if thrown by JDBC methods
See Also:
  - `ResultSet.getCharacterStream(int)`

### getLobCreator

public LobCreator getLobCreator()
Deprecated.
Description copied from interface: `LobHandler`
Create a new `LobCreator` instance, i.e. a session for creating BLOBs and CLOBs. Needs to be closed after the created LOBs are not needed anymore - typically after statement execution or transaction completion.

Returns:
  the new LobCreator instance
See Also:
  - `LobCreator.close()`